
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class MembershipsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const memberships = await db.memberships.create(
            {
                id: data.id || undefined,
        
        status: data.status
        ||
        null
            ,
            
        started_at: data.started_at
        ||
        null
            ,
            
        current_period_end_at: data.current_period_end_at
        ||
        null
            ,
            
        canceled_at: data.canceled_at
        ||
        null
            ,
            
        stripe_customer_ref: data.stripe_customer_ref
        ||
        null
            ,
            
        stripe_subscription_ref: data.stripe_subscription_ref
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await memberships.setUser( data.user || null, {
            transaction,
        });
        
        await memberships.setMembership_plan( data.membership_plan || null, {
            transaction,
        });
        

        

        

        return memberships;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const membershipsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                status: item.status
            ||
            null
            ,
            
                started_at: item.started_at
            ||
            null
            ,
            
                current_period_end_at: item.current_period_end_at
            ||
            null
            ,
            
                canceled_at: item.canceled_at
            ||
            null
            ,
            
                stripe_customer_ref: item.stripe_customer_ref
            ||
            null
            ,
            
                stripe_subscription_ref: item.stripe_subscription_ref
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const memberships = await db.memberships.bulkCreate(membershipsData, { transaction });

        // For each item created, replace relation files
        

        return memberships;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const memberships = await db.memberships.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.started_at !== undefined) updatePayload.started_at = data.started_at;
        
        
        if (data.current_period_end_at !== undefined) updatePayload.current_period_end_at = data.current_period_end_at;
        
        
        if (data.canceled_at !== undefined) updatePayload.canceled_at = data.canceled_at;
        
        
        if (data.stripe_customer_ref !== undefined) updatePayload.stripe_customer_ref = data.stripe_customer_ref;
        
        
        if (data.stripe_subscription_ref !== undefined) updatePayload.stripe_subscription_ref = data.stripe_subscription_ref;
        
        
        updatePayload.updatedById = currentUser.id;

        await memberships.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await memberships.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.membership_plan !== undefined) {
            await memberships.setMembership_plan(
              
              data.membership_plan,
              
              { transaction }
            );
        }
        

        
        

        

        return memberships;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const memberships = await db.memberships.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of memberships) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of memberships) {
                await record.destroy({transaction});
            }
        });


        return memberships;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const memberships = await db.memberships.findByPk(id, options);

        await memberships.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await memberships.destroy({
            transaction
        });

        return memberships;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const memberships = await db.memberships.findOne(
            { where },
            { transaction },
        );

        if (!memberships) {
            return memberships;
        }

        const output = memberships.get({plain: true});

        
        
        
        
        
        
        
        
        output.stripe_events_membership = await memberships.getStripe_events_membership({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await memberships.getUser({
            transaction
        });
        
        
        output.membership_plan = await memberships.getMembership_plan({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.membership_plans,
        as: 'membership_plan',
        
        where: filter.membership_plan ? {
          [Op.or]: [
            { id: { [Op.in]: filter.membership_plan.split('|').map(term => Utils.uuid(term)) } },
            {
              plan_name: {
                [Op.or]: filter.membership_plan.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.stripe_customer_ref) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'memberships',
                        'stripe_customer_ref',
                        filter.stripe_customer_ref,
                    ),
                };
            }
            
            if (filter.stripe_subscription_ref) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'memberships',
                        'stripe_subscription_ref',
                        filter.stripe_subscription_ref,
                    ),
                };
            }
            

            
            

            
            if (filter.started_atRange) {
                const [start, end] = filter.started_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.current_period_end_atRange) {
                const [start, end] = filter.current_period_end_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    current_period_end_at: {
                    ...where.current_period_end_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    current_period_end_at: {
                    ...where.current_period_end_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.canceled_atRange) {
                const [start, end] = filter.canceled_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    canceled_at: {
                    ...where.canceled_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    canceled_at: {
                    ...where.canceled_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.memberships.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'memberships',
                        'stripe_subscription_ref',
                        query,
                    ),
                ],
            };
        }

        const records = await db.memberships.findAll({
            attributes: [ 'id', 'stripe_subscription_ref' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['stripe_subscription_ref', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.stripe_subscription_ref,
        }));
    }

    
};

